import 'dart:collection';

import 'package:flutter/rendering.dart';
import 'package:flutter/widgets.dart';

import '../../logger/logger.dart';
import '../widgets_binding.dart';
import '../../webview_tracking/webview_tracking.dart';
import '../compression.dart';
import '../element_extension.dart';
import '../unmodifiable_list_view_extension.dart';
import 'get_element_data_of_hit_render_object.dart';
import 'hit_element_data.dart';
import 'results/hit_leaves_element_tvps_result.dart';
import 'results/hit_maybe_result.dart';

part 'get_leaves_element_tvps.dart';


UnmodifiableListView<String> a249(Offset a524) {
  final a367 = _a251(a524);

  final a368 = a267(
    a535: a367,
    a536: a140.a232(a500: a524),
  );

  a250() => UnmodifiableListView<String>([]);

  return a368.a13(
    a427: () {
      
      
      
      
      
      a187.a39(
        a150(
          a525: a524,
          a526: a367,
        ),
      );
      return a250();
    },
    a428: (hitElementData) {
      final a369 = hitElementData.a69.a85;
      if (a369.a225) {
        
        
        return a250();
      }

      final a370 = _a252(
        a528: hitElementData,
      );

      return a370.a9(
        
        a416: () => a250(),
        a417: (leavesScreengraphTVPs) {
          
          
          final a371 =
              leavesScreengraphTVPs.a259();

          final a372 =
              a371.map(a193).toList();

          return UnmodifiableListView(a372);
        },
      );
    },
  );
}


@visibleForTesting
class a150 extends a122 {
  
  a150({
    required Offset a525,
    required RenderObject a526,
  }) : super(
          'Could not find the element associated with the RenderObject $a526 that was found for the gesture at $a525',
        );
}


RenderObject _a251(Offset a527) {
  final a373 = a180.a207!.renderView;

  
  
  final a374 = BoxHitTestResult();
  a373.hitTest(a374, position: a527);

  
  return a374.path
      .firstWhere((element) => element.target is RenderObject)
      .target as RenderObject;
}